#include "effetti.h"         
#include "reffetti.h"
#include "cession.h"
#include "ef0301.h"

TDistinta::TDistinta(const TRectype& rec)
{      
   read(rec);                           
}

TDistinta::TDistinta(const char tipo, const long numero)
{      
   read(tipo,numero);                           
}

int TDistinta::read(const char tipo, const long numero)
{ 
  int err = NOERR;
  CHECK(tipo!='\0' && numero > 0,"Can't read distinta from NULL elements");
  TLocalisamfile f(LF_EFFETTI); 
  for (int i=0; err == NOERR ; i++)
  {
    TEffetto* effetto = new TEffetto; 
    err = effetto->read(f, tipo, numero, i+1);
    if (err == NOERR)
      _righe_dist.add(effetto);
  }
  if ((_righe_dist.items()>0)||(err == _iseof) ) 
    err = NOERR;                                
  return err;
}
  
int TDistinta::read(const TRectype& rec)
{ 
  CHECK(rec.num() == LF_EFFETTI,"Can't read distinta from a different record type");
  const char tipo = rec.get_char(EFF_TIPODIST);
  const long numero = rec.get_long(EFF_NDIST);
  return read(tipo,numero);
} 

int TDistinta::write(bool force, TToken_string* dati_dist)
{ 
  int err = NOERR;
  const int elem = items();
  TLocalisamfile f(LF_EFFETTI);
  for (int i=0; i<elem && err==NOERR; i++)
  {
    TEffetto& effetto = (TEffetto&)_righe_dist[i];
    dati_dist->restart();
    effetto.put("TIPODIST", dati_dist->get());
    effetto.put("NDIST", dati_dist->get_long());   
    effetto.put("DATADIST", dati_dist->get()); 
    effetto.put("CODABIP", dati_dist->get_long());
    effetto.put("CODCABP", dati_dist->get_long());  
    effetto.put("NRIGADIST", i+1);
    
    err = effetto.rewrite(f);
  }    
  return err;  
}

int TDistinta::remove(char tipodist, long ndist)
{
  int err;
  //elimino dal file
  TLocalisamfile file(LF_EFFETTI);
  for (int i = 0; i < items(); i++)
  { 
    TEffetto& effetto = (TEffetto&)_righe_dist[i];
    err = effetto.read(file, tipodist,ndist,i+1);
    effetto.zero("TIPODIST");
    effetto.zero("NDIST");
    effetto.zero("DATADIST");
    effetto.zero("NRIGADIST");
    effetto.zero("CODABIP");
    effetto.zero("CODCABP");
    err = effetto.rewrite(file);
  }
  reset();
  return err;  
}                        
